LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity cont8_dec_as_load_tb is
end cont8_dec_as_load_tb;

architecture testbench of cont8_dec_as_load_tb is

  component cont8_dec_as_load is
    port (clock : in  std_logic;
          load  : in  std_logic;
          X     : in std_logic_vector(7 downto 0);
          Z     : out std_logic_vector(7 downto 0)
         );
  end component;

  signal Z, X  : std_logic_vector (7 downto 0);
  signal clock     : std_logic;
  signal load     : std_logic;
  signal ris, flag : std_logic := '0';
  signal t_clk : std_logic_vector(7 downto 0); -- dovrebbe assumere il valore precedente assunto da Z (dato da clock)
  signal t_load : std_logic_vector(7 downto 0); -- deve assumere il valore dato da load
begin
  uut : cont8_dec_as_load port map (clock, load, X, Z);

  -- finche' ris vale 0 tutto dovrebbe andare bene.
  ris <= '0' when (((Z = t_clk - "00000001") or
                   (flag = '1' and Z = t_load))
                   and (not is_X(Z))
                  )
         else '1';

 t_load_p : process(load, X)
 begin
   if load = '1' then
     t_load <= X;
   end if;
 end process;
 
  flag_p : process(load, clock)
    -- flag viene usato per segnalare un'azione di load.
    -- flag viene posto a 1 da load,
    -- ma viene rimesso a 0 dal clock successivo,
    -- se reset  tornato a 0
  begin
    if load = '1' then
      flag <= '1';
    elsif clock'event and clock = '1' then
      flag <= '0';
    end if;
  end process;

  load_p : process
  begin
    load <= '1';
    wait for 8 ns;
    load <= '0';
    wait for 23 ns;
    load <= '1';
    wait for 1 ns;
    load <= '0';
    wait for 10 ns;
    load <= '1';
    wait for 1 ns;
    load <= '0';
    wait for 100 ns;
    load <= '1';
    wait for 1 ns;
    load <= '0';
    wait for 56 ns;
    load <= '1';
    wait for 1 ns;
  end process;

  X_p : process                         -- un po' di valori a caso
  begin
    X <= "11110101";
    wait for 3 ns;
    X <= "01000101";
    wait for 4 ns;
    X <= "00101100";
    wait for 9 ns;
    X <= "10000011";
    wait for 9 ns;
    X <= "01010100";
    wait for 9 ns;
    X <= "00110101";
    wait for 9 ns;
    X <= "00011100";
    wait for 9 ns;
    X <= "10110011";
    wait for 9 ns;
    X <= "01000100";
    wait for 9 ns;
    X <= "10001101";
    wait for 9 ns;
    X <= "01110000";
    wait for 9 ns;
    X <= "01011011";
    wait for 9 ns;
    X <= "00111000";
    wait for 9 ns;
    X <= "11110101";
    wait for 9 ns;
    X <= "01111100";
    wait for 9 ns;
    X <= "11111011";
    wait for 9 ns;
  end process;

  clock_p : process
  begin
    clock <= '0';
    wait for 5 ns;
    t_clk <= Z;
    clock <= '1';
   wait for 5 ns;
  end process;
    
end testbench;
















