LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity cont8_sin_reset_up_tb is
end cont8_sin_reset_up_tb;

architecture testbench of cont8_sin_reset_up_tb is

  component cont8_sin_reset_up is
    port (clock : in  std_logic;
          reset : in  std_logic;
          up    : in  std_logic;
          Z     : out std_logic_vector(7 downto 0)
         );
  end component;

  signal Z      : std_logic_vector (7 downto 0);
  signal clock     : std_logic;
  signal reset     : std_logic;
  signal up     : std_logic;
  signal ris, flag_up : std_logic := '0';
  signal t : std_logic_vector(7 downto 0); -- dovrebbe assumere il valore precedente assunto da Z
begin
  uut : cont8_sin_reset_up port map (clock, reset, up, Z);

  -- finche' ris vale 0 tutto dovrebbe andare bene.
  ris_p : process (clock, reset, up, Z)
  begin
    if clock'event and clock = '1' then
      if up = '1' then
        flag_up <= '1';
      else
        flag_up <= '0';
      end if;
      if reset = '1' then
        if up = '1' then
          t <= "00000000" - '1';
        else
          t <= "00000000" + '1';
        end if;
      else 
        t <= Z;
      end if;
    end if;
    if flag_up = '1' then
      if Z = t + '1' then 
        ris <= '0';
      else 
        ris <= '1';
      end if;
    else
      if Z = t - '1' then 
        ris <= '0';
      else 
        ris <= '1';
      end if;
    end if;
  end process;

  reset_p : process
  begin
    reset <= '1';
    wait for 15 ns;
    reset <= '0';
    wait for 23 ns;
    reset <= '1';
    wait for 1 ns;
    reset <= '0';
    wait for 10 ns;
    reset <= '1';
    wait for 1 ns;
    reset <= '0';
    wait for 100 ns;
    reset <= '1';
    wait for 1 ns;
    reset <= '0';
    wait for 56 ns;
    reset <= '1';
    wait for 1 ns;
  end process;

  up_p : process
  begin
    up <= '1';
    wait for 103 ns;
    up <= '0';
    wait for 59 ns;
    up <= '1';
    wait for 32 ns;
    up <= '0';
    wait for 2 ns;
    up <= '1';
    wait for 20 ns;
    up <= '0';
    wait for 208 ns;
  end process;

  clock_p : process
  begin
    clock <= '1';
    wait for 5 ns;
    clock <= '0';
    wait for 5 ns;
  end process;

end testbench;









