entity reg6_tb is
end reg6_tb;

architecture testbench of reg6_tb is

  component reg6 is
    port (X     : in  bit_vector(5 downto 0);
          clock : in  bit;
          Z     : out bit_vector(5 downto 0)
         );
  end component;

  signal X, Z      : bit_vector (5 downto 0);
  signal clock     : bit;
  signal ris, flag : bit := '0';
  signal t : bit_vector (5 downto 0);

begin
  uut : reg6 port map (X, clock, Z);

  ris <= '0' when ((flag = '1' and Z = X) or
                   (flag = '0' and Z = t)
                  )
         else '1';

  flag_p : process(X, clock)
  begin
    if X'event then
      flag <= '0';
    end if;
    if clock'event and clock = '1' then
      flag <= '1';
    end if;
  end process;

  X_p : process                         -- un po' di valori a caso
  begin
    X <= "000000";
    wait for 10 ns;
    X <= "010000";
    wait for 10 ns;
    X <= "001010";
    wait for 10 ns;
    X <= "100011";
    wait for 10 ns;
    X <= "000100";
    wait for 10 ns;
    X <= "010101";
    wait for 10 ns;
    X <= "000110";
    wait for 10 ns;
    X <= "110111";
    wait for 10 ns;
    X <= "101000";
    wait for 10 ns;
    X <= "101001";
    wait for 10 ns;
    X <= "000110";
    wait for 10 ns;
    X <= "010001";
    wait for 10 ns;
    X <= "001010";
    wait for 10 ns;
    X <= "110101";
    wait for 10 ns;
    X <= "011110";
    wait for 10 ns;
    X <= "111111";
    wait for 10 ns;

  end process;

  clock_p : process
  begin
    clock <= '0';
    wait for 11 ns;
    clock <= '1';
    t <= X;
    wait for 11 ns;
  end process;

end testbench;



