entity reg6_as_reset_tb is
end reg6_as_reset_tb;

architecture testbench of reg6_as_reset_tb is

  component reg6_as_reset is
    port (X     : in  bit_vector(5 downto 0);
          clock : in  bit;
          reset : in  bit;
          Z     : out bit_vector(5 downto 0)
         );
  end component;

  signal X, Z      : bit_vector (5 downto 0);
  signal clock     : bit;
  signal reset     : bit;
  signal ris, flag_clk, flag_rst : bit := '0';
  signal t : bit_vector (5 downto 0);

begin
  uut : reg6_as_reset port map (X, clock, reset, Z);

  -- finche' ris vale 0 tutto dovrebbe andare bene.
  ris <= '0' when ((flag_rst = '1' and Z = "000000") or
                   (flag_clk = '1' and Z = X) or
                   (flag_clk = '0' and Z = t)
                  )
         else '1';

  flag_clk_p : process(X, clock)
    -- flag_clk viene usato per segnalare il cambiamento
    -- di X in assenza di un battito di clock.
    -- flag_rst viene posto a 1 da clock
    -- e a 0 da X.
  begin 
    if X'event then
      flag_clk <= '0';
    end if;
    if clock'event and clock = '1' then
      flag_clk <= '1';
    end if;
  end process;

  flag_rst_p : process(reset, clock)
    -- flag_rst viene usato per segnalare un'azione di reset.
    -- flag_rst viene posto a 1 da reset,
    -- ma viene rimesso a 0 dal clock successivo,
    -- se reset  tornato a 0
  begin
    if reset = '1' then
      flag_rst <= '1';
    elsif clock'event and clock = '1' then
      flag_rst <= '0';
    end if;
  end process;

  X_p : process                         -- un po' di valori a caso
  begin
    X <= "000000";
    wait for 10 ns;
    X <= "010001";
    wait for 10 ns;
    X <= "001010";
    wait for 10 ns;
    X <= "100011";
    wait for 10 ns;
    X <= "010100";
    wait for 10 ns;
    X <= "001101";
    wait for 10 ns;
    X <= "000110";
    wait for 10 ns;
    X <= "100111";
    wait for 10 ns;
    X <= "010000";
    wait for 10 ns;
    X <= "100001";
    wait for 10 ns;
    X <= "000010";
    wait for 10 ns;
    X <= "010011";
    wait for 10 ns;
    X <= "001100";
    wait for 10 ns;
    X <= "110101";
    wait for 10 ns;
    X <= "010110";
    wait for 10 ns;
    X <= "111111";
    wait for 10 ns;
  end process;

  reset_p : process
  begin
    reset <= '0';
    wait for 23 ns;
    reset <= '1';
    wait for 1 ns;
    reset <= '0';
    wait for 10 ns;
    reset <= '1';
    wait for 1 ns;
    reset <= '0';
    wait for 100 ns;
    reset <= '1';
    wait for 1 ns;
    reset <= '0';
    wait for 56 ns;
    reset <= '1';
    wait for 1 ns;
  end process;

  clock_p : process
  begin
    clock <= '0';
    wait for 11 ns;
    clock <= '1';
    t <= X;
    wait for 11 ns;
  end process;

end testbench;





