entity reg8_tb is
end reg8_tb;

architecture testbench of reg8_tb is

  component reg8 is
    port (X     : in  bit_vector(7 downto 0);
          clock : in  bit;
          Z     : out bit_vector(7 downto 0)
         );
  end component;

  signal X, Z      : bit_vector (7 downto 0);
  signal clock     : bit;
  signal ris, flag : bit := '0';
  signal t : bit_vector (7 downto 0);

begin
  uut : reg8 port map (X, clock, Z);

  ris <= '0' when ((flag = '1' and Z = X) or
                   (flag = '0' and Z = t)
                  )
         else '1';

  flag_p : process(X, clock)
  begin
    if X'event then
      flag <= '0';
    end if;
    if clock'event and clock = '1' then
      flag <= '1';
    end if;
  end process;

  X_p : process                         -- un po' di valori a caso
  begin
    X <= "00000000";
    wait for 10 ns;
    X <= "01000001";
    wait for 10 ns;
    X <= "00100010";
    wait for 10 ns;
    X <= "10000011";
    wait for 10 ns;
    X <= "01000100";
    wait for 10 ns;
    X <= "00100101";
    wait for 10 ns;
    X <= "00010110";
    wait for 10 ns;
    X <= "10010111";
    wait for 10 ns;
    X <= "01001000";
    wait for 10 ns;
    X <= "10001001";
    wait for 10 ns;
    X <= "00001010";
    wait for 10 ns;
    X <= "01001011";
    wait for 10 ns;
    X <= "00101100";
    wait for 10 ns;
    X <= "11001101";
    wait for 10 ns;
    X <= "01011110";
    wait for 10 ns;
    X <= "11111111";
    wait for 10 ns;

  end process;

  clock_p : process
  begin
    clock <= '0';
    wait for 11 ns;
    clock <= '1';
    t <= X;
    wait for 11 ns;
  end process;

end testbench;



